"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RulesEngine = void 0;
const engine_1 = require("./engine");
class RulesEngine {
    constructor(functionsTable, ruleFunctionsTable) {
        this.functionsTable = functionsTable;
        this.ruleFunctionsTable = ruleFunctionsTable;
    }
    async evaluate(rules, context, runOptions) {
        return (await (0, engine_1.evaluateRules)(rules, context, this.functionsTable, this.ruleFunctionsTable, true, runOptions))?.[0];
    }
    async evaluateAll(rules, context, runOptions) {
        return (0, engine_1.evaluateRules)(rules, context, this.functionsTable, this.ruleFunctionsTable, false, runOptions);
    }
    async validate(rules, validationContext, runOptions) {
        await (0, engine_1.validateRules)(rules, validationContext, this.functionsTable, this.ruleFunctionsTable, runOptions);
    }
}
exports.RulesEngine = RulesEngine;
//# sourceMappingURL=rulesEngine.js.map