import { AndCompareOp, Context, EqualCompareOp, ExtendedCompareOp, FuncCompares, FunctionsTable, BetweenCompareOp, GtCompareOp, GteCompareOp, LtCompareOp, LteCompareOp, RegexCompareOp, RegexiCompareOp, NotCompareOp, NotEqualCompareOp, OrCompareOp, InqCompareOp, NinCompareOp, RuleFunctionsTable, RuleFunctionsParams, MathOp } from '../types';
export declare const _isObject: (obj: unknown) => boolean;
export declare const isFunctionCompareOp: <C extends Context, F extends FunctionsTable<C, CustomEvaluatorFuncRunOptions>, Ignore, CustomEvaluatorFuncRunOptions>(expression: unknown, functionsTable: F, key: string) => expression is FuncCompares<C, F, CustomEvaluatorFuncRunOptions>;
export declare const isRuleFunction: <ConsequencePayload, C extends Context, RF extends RuleFunctionsTable<C, ConsequencePayload, CustomEngineRuleFuncRunOptions>, CustomEngineRuleFuncRunOptions>(expression: unknown, ruleFunctionsTable: RF, key: string) => expression is RuleFunctionsParams<ConsequencePayload, C, RF, CustomEngineRuleFuncRunOptions>;
export declare const isAndCompareOp: <C extends Context, F extends FunctionsTable<C, CustomEvaluatorFuncRunOptions>, Ignore, CustomEvaluatorFuncRunOptions>(expression: unknown) => expression is AndCompareOp<C, F, Ignore, CustomEvaluatorFuncRunOptions>;
export declare const isOrCompareOp: <C extends Context, F extends FunctionsTable<C, CustomEvaluatorFuncRunOptions>, Ignore, CustomEvaluatorFuncRunOptions>(expression: unknown) => expression is OrCompareOp<C, F, Ignore, CustomEvaluatorFuncRunOptions>;
export declare const isNotCompareOp: <C extends Context, F extends FunctionsTable<C, CustomEvaluatorFuncRunOptions>, Ignore, CustomEvaluatorFuncRunOptions>(expression: unknown) => expression is NotCompareOp<C, F, Ignore, CustomEvaluatorFuncRunOptions>;
export declare const isBetweenCompareOp: (op: ExtendedCompareOp<any, any, any>) => op is BetweenCompareOp<any, any>;
export declare const isGtCompareOp: (op: ExtendedCompareOp<any, any, any>) => op is GtCompareOp<any, any>;
export declare const isGteCompareOp: (op: ExtendedCompareOp<any, any, any>) => op is GteCompareOp<any, any>;
export declare const isLteCompareOp: (op: ExtendedCompareOp<any, any, any>) => op is LteCompareOp<any, any>;
export declare const isLtCompareOp: (op: ExtendedCompareOp<any, any, any>) => op is LtCompareOp<any, any>;
export declare const isRegexCompareOp: (op: ExtendedCompareOp<any, any, any>) => op is RegexCompareOp<any, any>;
export declare const isRegexiCompareOp: (op: ExtendedCompareOp<any, any, any>) => op is RegexiCompareOp<any, any>;
export declare const isEqualCompareOp: (op: ExtendedCompareOp<any, any, any>) => op is EqualCompareOp<any, any, any>;
export declare const isNotEqualCompareOp: (op: ExtendedCompareOp<any, any, any>) => op is NotEqualCompareOp<any, any, any>;
export declare const isInqCompareOp: (op: ExtendedCompareOp<any, any, any>) => op is InqCompareOp<any, any, any>;
export declare const isNinCompareOp: (op: ExtendedCompareOp<any, any, any>) => op is NinCompareOp<any, any, any>;
export type WithRef = {
    ref: string;
};
export declare const isWithRef: (x: unknown) => x is WithRef;
export declare const isMathOp: (x: unknown) => x is MathOp<any, any>;
